<?php


class wps_ic_js_delay
{

  public static $excludes;
  public static $footerScripts;

  public function __construct() {
    self::$excludes = new wps_ic_excludes();
  }


  public function printFooterScripts() {
    $html = '';

    if (!empty(self::$footerScripts)) {
      foreach (self::$footerScripts as $script) {
        $html .= $script[0];
      }
    }

    return $html . '</body>';
  }

  public function scriptsToFooter($tag) {
    $original_tag = $tag;
    if (is_array($tag)) {
      $tag = $tag[0];
    }
    if (is_array($tag)) {
      $tag = $tag[0];
    }
    if (self::$excludes->strInArray($tag, self::$excludes->scriptsToFooterExcludes())) {
      return $tag;
    }
    self::$footerScripts[] = $original_tag;
    return '';
  }


  public function preload_scripts($tag) {
    if (is_array($tag)) {
      $fullTag = $tag[0];
    }

    $tagLower = strtolower($fullTag);

    if (strpos($tagLower, 'src=') !== false) {
      $src = $tag[1];
      if(strpos($src, 'google') === false && strpos($src, 'tracking') === false && strpos($src, 'optimize.js') === false) {
        return '<link rel="prefetch" href="' . $src . '" as="script">' . $fullTag;
      }
    }

    return $fullTag;
  }


  public function removeNoDelay($tag) {
    if (is_array($tag)) {
      $tag = $tag[0];
    }

    $tagLower = strtolower($tag);

    // It's excluded
    if (strpos($tagLower, 'text/javascript-no-delay') !== false) {
      $tag = str_replace('type="text/javascript-no-delay"', 'type="text/javascript"', $tag);
    }

    return $tag;
  }


  public function delay_script_replace($tag) {

    if (!empty($_GET['removeScripts'])) {
      return '';
    }

    if (is_array($tag)) {
      $tag = $tag[0];
    }

    $tagLower = strtolower($tag);

    if (strpos($tagLower, 'gtag') !== false) {
      if (preg_match('/<script[^>]*>/i', $tagLower, $matches ) && strpos( $matches[0], 'type=' ) === false ) {
        $tag = preg_replace( '/<script/i', '<script type="wpc-delay-last-script"', $tag, 1 );
      } else {
        $tag = str_replace( [ 'type="text/javascript"', "type='text/javascript'", 'type="application/javascript"', "type='application/javascript'" ], 'type="wpc-delay-last-script"', $tag );
      }
      return $tag;
    }

	  if (self::$excludes->excludedFromDelay($tag)) {
      if (strpos($tagLower, 'defer') == false && strpos($tagLower, 'jquery') === false) {
        $tag = str_replace('<script ', '<script async data-wpc-att="excluded" ', $tag);
      }
		  return $tag;
	  }

    if (strpos($tagLower, 'n489d_vars') !== false || strpos($tagLower, 'optimize.js') !== false) {
      // Do not delay these!!!
      return $tag;
    } elseif (strpos($tagLower, 'scripts.min.js') !== false || strpos($tagLower, 'fusion-scripts') !== false || strpos($tagLower, 'tracking') !== false || strpos($tagLower, 'googletagmanager') !== false || strpos($tagLower, 'gtag') !== false) {
      // Patches for scripts that need to run last?
      #$tag = str_replace('type="text/javascript"', 'type="wpc-delay-last-script"', $tag);
      if (preg_match('/<script[^>]*>/i', $tagLower, $matches ) && strpos( $matches[0], 'type=' ) === false ) {
        $tag = preg_replace( '/<script/i', '<script type="wpc-delay-last-script"', $tag, 1 );
      } else {
        $tag = str_replace( [ 'type="text/javascript"', "type='text/javascript'", 'type="application/javascript"', "type='application/javascript'" ], 'type="wpc-delay-last-script"', $tag );
      }

      return $tag;
    } else {
      // Find & Replace with delay
      if (preg_match('/<script[^>]*>/i', $tagLower, $matches ) && strpos( $matches[0], 'type=' ) === false ) {
        $tag = preg_replace( '/<script/i', '<script type="wpc-delay-script"', $tag, 1 );
      } else {
        $tag = str_replace( [ 'type="text/javascript"', "type='text/javascript'", 'type="application/javascript"', "type='application/javascript'" ], 'type="wpc-delay-script"', $tag );
      }
      return $tag;
    }


    return $tag;
  }


}